#!/usr/local/bin/perl
#### եHTTPեץ upload.cgi V4.00 
#### Copyright 1998-2005 GORRY. 
#### mailto: gorry@hauN.org 
#### 
#### History: 
#### 2005/04/22 V4.00 С󳫻ϡ
#### 2004/05/14 V3.00 С󳫻ϡ
#### 2000/11/07 V2.30 ޥե֥ߥ˥顼ɽ褦
#### 2000/11/07 V2.20 ѥ᡼ִб
####                  ξǼ³Τʤ顼åɽХ
#### 2000/01/12 V2.01 GETDIRб
#### 1999/09/30 V2.00 ˥塼롣
#### 1998/12/16 V1.03 prev/today/nextб
#### 1998/12/15 V1.02 դ0/0/0ȡlastuploadեդȤƲ᤹롣
#### 1998/12/14 V1.01 ƥȥ⡼ɡʹ˷ɽˤɲá 
####                  եιб 
#### 1998/12/13 V1.00  

require "libgns.pl";

{
	&Setup_KEEPDIR();

	print "Content-Type: text/html; charset=EUC-JP\n\n";

	# set lockfile
	$lockorg = "$TMPDIR/lockorg";
	$lockfile = "$TMPDIR/lockfile";
	open( LOCK, ">$lockorg" ) || die "Semaphore [$lockorg] cannot set.\n";

	close( LOCK );
	$abort_counter = 60;
	$not_aborted = 1;
	$SIG{'__DIE__'} = $SIG{'TRAP'} = $SIG{'ABRT'} = $SIG{'STOP'} = $SIG{'TERM'} = $SIG{'INT'} = $SIG{'KILL'} = $SIG{'QUIT'} = $SIG{'HUP'} = $SIG{'PIPE'} = 'doterm';

	# set semaphore
	while(!link($lockorg,$lockfile)) {
		$abort_counter--;
		if ( $abort_counter eq 0 ) {
			$not_aborted = 0;
			last;
		}
		sleep(1);
	}
	if ( !$not_aborted ) {
		print "Semaphore [$lockfile] cannot set.\n";
		exit(1);
	}

	&do_main();

	# reset semaphore
	unlink($lockfile);

	# display error
	open ( FILE, "$TMPDIR/cgierr.log" );
	while (<FILE>) {
		print;
	}
	close( FILE );

	# display result
	for ( $i=0; $i<$lines; $i++ ) {
		print $line[$i];
	}

	if ( $mode eq "test" ) {
		system( "cp $TMPDIR/%back.out $file >/dev/null" );
	}

	exit(0);
}

sub doterm
{
	unlink($lockfile);
}

sub do_main
{
	open( SAVEERR, ">&STDERR" );
	open( STDERR, ">$TMPDIR/cgierr.log" );
	select( STDERR ); $| = 1; select( STDOUT );
	eval {

	if ( $ENV{'REQUEST_METHOD'} eq "POST" ) {
		$len = $ENV{'CONTENT_LENGTH'} + 0;
		read( STDIN, $str, $len );
	} else {
		$str = $ENV{'QUERY_STRING'};
	}

	@part = split( '&', $str );
	foreach $i (@part) {
		( $variable, $value ) = split( '=', $i );
		$value =~ tr/+/ /;
		$value =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C", hex($1))/eg;
		&jcode'convert( *value, 'sjis' );
		$value =~ s/\015\012/\012/g;
		$value =~ s/\015/\012/g;
		if ( $cgi{$variable} eq "" ) {
			$cgi{$variable} = $value;
		} else {
			$cgi{$variable} .= "," . $value;
		}
	}

	$year = $cgi{ 'year' }+0;
	$month = $cgi{ 'month' }+0;
	$day = $cgi{ 'date' }+0;
	$body = $cgi{ 'body' };
	$pass = $cgi{ 'pass' };
	$mode = $cgi{ 'mode' };
	$makeindex = $cgi{ 'makeindex' };
	$updateping = $cgi{ 'updateping' };
	$tbtitleno = substr( $cgi{"title"}, 3 )+0;
	$url = $cgi{ 'url' };
	$command = $cgi{ 'command' };
	$editdb = $cgi{ 'editdb' };

	( $sec_2,$min_2,$hour_2,$mday_2,$mon_2,$year_2,$wday_2,$yday_2,$isdst ) = localtime( time );
	$year_2 += 1900;
	$mon_2 += 1;

	&jcode'convert( *body, 'sjis' );

	open( PASS, "$KEEPDIR/upload.pass" ) || die "[$KEEPDIR/upload.pass] not exist. Please register PASSWORD!\n";
	$passwd = <PASS>;
	close(PASS);
	$passx = crypt( $pass, "gns" );

	while (1) {
#	$year = 1998;
#	$month = 12;
#	$day = 13;
#	$mode = "write";
#	$pass = $passwd;

		# check
		$gnsfile = 0;
		if ( $command ne " OK " ) {
			$mode = $command;
		}
		if ( $command eq "latest" ) {
			$year = 0;
			$month = 0;
			$day = 0;
		} elsif ( $command eq "Call" ) {
			if ( $editdb eq "D-Head" ) {
				$year = 10;
				$month = 99;
				$day = 99;
			} elsif ( $editdb eq "D-Memo1" ) {
				$year = 11;
				$month = 99;
				$day = 99;
			} elsif ( $editdb eq "D-Memo2" ) {
				$year = 20;
				$month = 99;
				$day = 99;
			} elsif ( $editdb eq "D-Foot" ) {
				$year = 21;
				$month = 99;
				$day = 99;
			} elsif ( $editdb eq "B-Head" ) {
				$year = 30;
				$month = 99;
				$day = 99;
			} elsif ( $editdb eq "B-Foot" ) {
				$year = 40;
				$month = 99;
				$day = 99;
			} elsif ( $editdb eq "L1-Head" ) {
				$year = 50;
				$month = 99;
				$day = 99;
			} elsif ( $editdb eq "L1-Foot" ) {
				$year = 51;
				$month = 99;
				$day = 99;
			} elsif ( $editdb eq "L2-Head" ) {
				$year = 52;
				$month = 99;
				$day = 99;
			} elsif ( $editdb eq "L2-Foot" ) {
				$year = 53;
				$month = 99;
				$day = 99;
			} elsif ( $editdb eq "TB-Head" ) {
				$year = 60;
				$month = 99;
				$day = 99;
			} elsif ( $editdb eq "TB-Foot" ) {
				$year = 61;
				$month = 99;
				$day = 99;
			} elsif ( $editdb eq "Ping" ) {
				$year = 96;
				$month = 99;
				$day = 99;
			} elsif ( $editdb eq "Item" ) {
				$year = 98;
				$month = 99;
				$day = 99;
			} elsif ( $editdb eq "URI" ) {
				$year = 99;
				$month = 99;
				$day = 99;
			} elsif ( $editdb eq "Macro" ) {
				$year = 97;
				$month = 99;
				$day = 99;
			} elsif ( $editdb eq "TBFilter" ) {
				$year = 101;
				$month = 99;
				$day = 99;
			} elsif ( $editdb eq "CMFilter" ) {
				$year = 102;
				$month = 99;
				$day = 99;
			}
		}
		if ( ($year >= 100) &&
		     ($year <= 199) &&
		     ($month == 99) &&
		     ($day == 99) ) {
			if ( $year == 101 ) {
				$file = "$PUTDIR/$TRACKBACKDIR/tbfilter.txt";
			} elsif ( $year == 102 ) {
				$file = "$PUTDIR/$TRACKBACKDIR/cmfilter.txt";
			}
			$gnsfile = 1;
		} elsif ( ($year >= 10) &&
		     ($year <= 99) &&
		     ($month == 99) &&
		     ($day == 99) ) {
			$file = sprintf( "$KEEPDIR/%02d.html", $year );
			$gnsfile = 1;
		} elsif ( ($cgi{ 'year'  } eq "") &&
		          ($cgi{ 'month' } eq "") &&
		          ($cgi{ 'date'  } eq "") ) {
			$mode = "read";
			if ( open( FILE, "$KEEPDIR/lastupload" ) ) {
				$_ = <FILE>;
				close( FILE );
				@a = split;
				$year = $a[0]+0;
				$month = $a[1]+0;
				$day = $a[2]+0;
			} else {
				$year = $year_2;
				$month = $mon_2;
				$day = $mday_2;
			}
		} elsif ( ($cgi{ 'year'  } eq "") ||
		          ($cgi{ 'month' } eq "") ||
		          ($cgi{ 'date'  } eq "") ) {
			print "Year/Month/Date($cgi{'year'}, $cgi{'month'}, $cgi{'date'}, ) date Error.\n";
			last;
		} elsif ( ($year == 0) &&
		          ($month == 0) &&
		          ($day == 0) ) {
			$mode = "read";
			if ( open( FILE, "$KEEPDIR/lastupload" ) ) {
				$_ = <FILE>;
				close( FILE );
				@a = split;
				$year = $a[0]+0;
				$month = $a[1]+0;
				$day = $a[2]+0;
			} else {
				$year = $year_2;
				$month = $mon_2;
				$day = $mday_2;
			}
		} elsif ( ($year < 1980) ||
		          ($year > 2199) ||
		          ($month < 1)   ||
		          ($month > 12)  ||
		          ($day < 1)    ||
		          ($day > 31) ) {
			print "Year/Month/Date($year, $month, $day) date Error.\n";
			last;
		} else {
			$file = sprintf( "$GETDIR/%04d/%02d%02d.html", $year, $month, $day );
		}

		&ReadLastUpload();
		$LASTUPLOAD{"makeindex"} = $makeindex if ( defined $cgi{ 'command' } );
		$LASTUPLOAD{"updateping"} = $updateping if ( defined $cgi{ 'command' } );
		&WriteLastUpload( $YEAR, $MONTH, $DATE );

		while ( 1 ) {
			if ( !$gnsfile ) {
				$umaskback = umask( oct($DIARY_GETDIR_PERM) ^ 0777 );
				mkdir( "$GETDIR/$year", oct($DIARY_GETDIR_PERM) ) if ( !(-e "$GETDIR/$year") );
				umask( $umaskback );
			}
# print "[mode: $mode]\n";
			if ( $mode eq "write" ) {
				if ( $passx ne $passwd ) {
					print "Password Error. \n";
					last;
				}
				if ( $gnsfile ) {
					if ( -e $file ) {
						$umaskback = umask( oct($DIARY_TMP_PERM) ^ 0666 );
						system( "cp $file $TMPDIR/%back.out >/dev/null" );
						umask( $umaskback );
					}
					$umaskback = umask( oct($DIARY_KEEP_PERM) ^ 0666 );
					open( FOUT, ">$file" ) || die "[$file] cannot write. Check [$file] permission.";
					print FOUT "$body";
					close( FOUT );
					umask( $umaskback );
				} else {
					if ( -e $file ) {
						$umaskback = umask( oct($DIARY_TMP_PERM) ^ 0666 );
						system( "cp $file $TMPDIR/%back.out >/dev/null" );
						umask( $umaskback );
					}
					$umaskback = umask( oct($DIARY_GET_PERM) ^ 0666 );
					open( FOUT, ">$file" ) || die "[$file] cannot write. Check [$file] permission.";
					print FOUT "$body";
					close( FOUT );
					umask( $umaskback );
					$cmd = "$PERLCMD mkd.pl $year $month $day |";
					open ( FILE, $cmd ) || die "cannot execute [$cmd].";
					while (<FILE>) {
						print;
					}
					close( FILE );
					if ( $makeindex ) {
						$cmd = "$PERLCMD mkidx.pl $year |";
						open ( FILE, $cmd ) || die "cannot execute [$cmd].";
						while (<FILE>) {
							print;
						}
						close( FILE );
					}
					if ( $updateping ) {
						system( "$PERLCMD upsend.pl &" );
					}
				}
				if ( $FLAG_POSTMAIL ) {
					$cmd = "$PERLCMD postmail.pl $year $month $day $mode $pass |";
					open ( FILE, $cmd ) || die "cannot execute [$cmd].";
					while (<FILE>) {
						print;
					}
					close( FILE );
				}
			} elsif ( $mode eq "test" ) {
				$umaskback = umask( oct($DIARY_TMP_PERM) ^ 0666 );
				$backout = "$TMPDIR/%back.out";
				system( "rm $backout >/dev/null" ) if ( -e $backout );
				system( "touch $backout >/dev/null" );
				system( "cp $file $TMPDIR/%back.out >/dev/null" ) if ( -e $file );
				umask( $umaskback );
				$umaskback = umask( oct($DIARY_GET_PERM) ^ 0666 );
				open( FOUT, ">$file" ) || die "[$file] cannot write. Check [$file] permission.";
				print FOUT "$body";
				close( FOUT );
				umask( $umaskback );
			} elsif ( $mode eq "Send" ) {
				if ( $passx ne $passwd ) {
					print "Password Error. \n";
					last;
				}
				$cmd = "$PERLCMD tbsend.pl $year $month $day $tbtitleno $url |";
				open ( FILE, $cmd ) || die "cannot execute [$cmd].";
				while (<FILE>) {
					s/[&]/&amp;/g;
					s/[<]/&lt;/g;
					s/[>]/&gt;/g;
					print "$_<BR>";
				}
				close( FILE );
			}

			# display test
			$lines = 0;
			if ( $gnsfile ) {
				$command1 = "read";
				$cmd = "echo>$TMPDIR/test.html|";
				open ( FILE2, $cmd ) || die "cannot execute [$cmd].";
			} else {
				$command1 = "test";
				if ( $command eq "yesterday" ) {
					$command1 = "prev";
				}
				if ( $command eq "tomorrow" ) {
					$command1 = "next";
				}
				$cmd = "$PERLCMD mkd.pl $year $month $day $command1|";
				open ( FILE2, $cmd ) || die "cannot execute [$cmd].";
			}
			while (<FILE2>) {
				$line[$lines++] = $_;
			}
			close( FILE2 );

			# display terminate
			$cmd = "$PERLCMD mkup.pl $year $month $day $command1 $pass |";
			open ( FILE3, $cmd ) || die "cannot execute [$cmd].";
			while (<FILE3>) {
				$line[$lines++] = $_;
			}
			close( FILE3 );

			last;
		}

		last;
	}

	};
	if ( $@ ) {
		print STDERR $@;
	}
	close( STDERR );
	open( STDERR, ">&SAVEERR" );

}

1;
# [EOF]
