#!/usr/local/bin/perl
#### ե᡼ץ recvmail.awk V4.00 
#### Copyright 1998-2005 GORRY. 
#### mailto: gorry@hauN.org 
#### 
#### History: 
#### 2005/04/22 V4.00 С󳫻ϡ
#### 2004/05/14 V3.00 С󳫻ϡ
#### 2000/09/20 V2.11 ᡼sjis¸ʤХ
#### 2000/07/05 V2.10 config.awkѤ˽
#### 2000/01/12 V2.01 GETDIRб
#### 1999/09/30 V2.00 ˥塼롣 
#### 1999/09/29 V1.16 ѥɥå˰ư 
#### 1999/08/24 V1.14 PUTDIRꤷ˺Х
#### 1999/01/29 V1.10 եࡣ 
#### 1999/01/04 V1.06 ǯեʤbugfix 
#### 1998/12/17 V1.04  

$NKFCODE_RECVMAIL = '-s';  # Shift_JIS˸

$execpath = $0;
$execpath =~ s:/[^/]+$::;
chdir( $execpath ) if ( $execpath ne "" );

require "libgns.pl";

open(SAVEOUT, ">&STDOUT");
open(SAVEERR, ">&STDERR");
open( STDOUT, ">$TMPDIR/recvmail.log" );
open( STDERR, ">&STDOUT" );
select( STDERR ); $| = 1;
select( STDOUT ); $| = 1;

print "--- chdir [$execpath].\n" if ( $execpath ne "" );

eval {
	&Setup_KEEPDIR();

	&ReadLastUpload();
	&YMD2DAYS( $YEAR, $MONTH, $DATE );
	$totaldays_last = $TOTALDAYS;

	# ᡼إåɤ߼
	print "--- Read Mail Header.\n";
	$ok1 = 0;
	$ok2 = 0;
	while ( $line = <STDIN> ) {
		$line =~ s/[\012\015]+//;
		print "$line\n";
		if ( $line eq "" ) {
			print "--- Reject this mail.\n";
			die "reject this mail from recvmail.pl.";
		}
		if ( $line =~ m/[Ss][Uu][Bb][Jj][Ee][Cc][Tt]:[ \t]*${MAILSUBJECT}/ ) {
			print "--- Accept mail Subject.\n";
			$ok1 = 1;
		}
		if ( $line =~ m/[Ff][Rr][Oo][Mm]:[ \t]*(.*)$/ ) {
			$from = $1;
			foreach $s ( split( ",", $MAILFROM ) ) {
				$s =~ tr/ \t//;
				if ( $from =~ m/${s}/ ) {
					print "--- Accept mail From.\n";
					$ok2 = 1;
				}
			}
		}
		if ( $ok1 && $ok2 ) {
			print "--- Accept this mail.\n";
			last;
		}
	}

	# ᡼إåλĤɤФ
	print "--- Skip rest of Mail Header.\n";
	$ok = 0;
	while ( $line = <STDIN> ) {
		$line =~ s/[\012\015]+//;
		print "$line\n";
		if ( $line eq "" ) {
			$ok = 1;
			last;
		}
	}
	if ( $ok == 0 ) {
		print "--- End of Mail.\n";
		last;
	}
	print "--- Mail Header end.\n";

	# ɤ߼
	print "--- Get Diary Information.\n";
	$ok = 0;
	while ( $line = <STDIN> ) {
		$line =~ s/[\012\015]+//;
		print line;
		if ( $line eq "" ) {
			last if ( $ok );
			next;
		}
		@l = split( ' ', $line );
		if ( $l[0] eq '01' ) {
			$ok = 1;
			$year = $l[1];
			$month = $l[2];
			$day = $l[3];
			$pass = $l[4];
			print "--- Got Diary Information\n";
			next;
		}
		if ( $l[0] =~ m:#[Aa][Dd][Dd]: ) {
			$MAILADD = 1;
			print "--- MAILADD = 1\n";
			next;
		}
		if ( $l[0] =~ m:#[Oo][Vv][Ee][Rr]: ) {
			$MAILADD = 0;
			print "--- MAILADD = 0\n";
			next;
		}
		if ( $l[0] =~ m:#[Mm][Aa][Kk][Ee][Ii][Nn][Dd][Ee][Xx]: ) {
			$makeindex = $l[1]+0;
			$LASTUPLOAD{"makeindex"} = $makeindex;
			print "--- makeindex = $makeindex\n";
			next;
		}
		if ( $l[0] =~ m:#[Uu][Pp][Dd][Aa][Tt][Ee][Pp][Ii][Nn][Gg]: ) {
			$updateping = $l[1]+0;
			$LASTUPLOAD{"updateping"} = $updateping;
			print "--- updateping = $updateping\n";
			next;
		}
	}
	if ( $ok == 0 ) {
		print "--- Diary Information not found.\n";
		last line;
	}
	print "--- Diary information end.\n";

	# ѥɥå
	print "--- Check Password.\n";
	if ( $pass eq '' ) {
		print "--- No Password.\n";
		last;
	}
	$passx = crypt( $pass, "gns" );
	$passwdfile = $KEEPDIR . $SLASH . 'upload.pass';
	open( PASSWD, $passwdfile ) || die "cannot read [$passwdfile].";
	$passwd = <PASSWD>;
	close( PASSWD );
	if ( $passx ne $passwd ) {
		print "--- Password NG.\n";
		last;
	}
	print "--- Password OK.\n";

	# ޥ񤭽Ф
	print "--- Save Diary.\n";
	if ( ($month == 99) && ($day == 99) ) {
		$diary = sprintf( $KEEPDIR . $SLASH . '%02d.html', $year );
	} else {
		$dir = sprintf( $GETDIR . $SLASH . '%04d', $year );
		if ( !(-e $dir) ) {
			mkdir( $dir, oct($DIARY_GETDIR_PERM) );
		}
		$diary = sprintf($GETDIR . $SLASH . '%04d' . $SLASH . '%02d%02d.html',
		  $year, $month, $day
		);
	}
	$dputcmd = "|$NKFCMD $NKFCODE_RECVMAIL > $diary";
	if ( -e $diary ) {
		$dputcmd = "|$NKFCMD $NKFCODE_RECVMAIL >> $diary" if ( $MAILADD != 0 );
	}
	$umaskback = umask( oct($DIARY_GET_PERM) ^ 0666 );
	open( FOUT, $dputcmd );
	while ( $line = <STDIN> ) {
		print FOUT $line;
	}
	close( FOUT );
	umask( $umaskback );

	# ե
	if ( ($month == 99) && ($day == 99) ) {
		print "--- Skip Generate Diary.\n";
	} else {
		print "--- Generate Diary.\n";
		$cmd = "$PERLCMD mkd.pl $year $month $day";
		print "$cmd\n";
		system( $cmd );

		if ( $LASTUPLOAD{"makeindex"} ) {
			print "--- Generate Diary Index.\n";
			$cmd = "$PERLCMD mkidx.pl $year";
			print "$cmd\n";
			system( $cmd );
		}

		if ( $LASTUPLOAD{"updateping"} ) {
			print "--- Send Update Ping.\n";
			$cmd = "$PERLCMD upsend.pl &";
			print "$cmd\n";
			system( $cmd );
		}

		&YMD2DAYS( $year, $month, $day );
		$totaldays_today = $TOTALDAYS;
		if ( $totaldays_today > $totaldays_last ) {
			&WriteLastUpload( $year, $month, $day );
		}

	}

	print "--- Finished.\n";

};

close( STDOUT );
close( STDERR );
open( STDOUT, ">&SAVEOUT" );
open( STDOUT, ">&SAVEERR" );

0;
# [EOF]
